#include "ooclip.ch"

CLASS oDbf

VAR Who
VAR cAlias
VAR nOffset
*VAR nNewOffset // never needed...

// even though it says it's been fixed to allow any function name... //obsolete
// i found function name still must be: class_name+function_name.

METHOD New    = oDbfNew,;
       FldInit= oDbfFldInit     // new method

METHOD Browse = oDbfBrowse

METHOD Skip   = oDbfSkip,;
       Eof    = oDbfEof,;
       Bof    = oDbfBof,;
       GoTop  = oDbfGoTop,;
       GoBot  = oDbfGoBot

METHOD Add    = oDbfAppend,;
       Delete = oDbfDelete,;
       Recall = oDbfRecall,;
       ReIndex= oDbfReIndex,;
       Kill   = oDbfKill

METHOD Rlock  = oDbfRlock,;          // new method
       Flock  = oDbfFlock,;          // new method
       Unlock = oDbfUnlock           // new method

METHOD Read   = oDbfRead,;          // new method
       Write  = oDbfWrite           // new method
       
// aadd(handle,{ nposition, 4 } )   // manually save class handle, how many var are in class

ENDCLASS

*********************** open dbf, set index, add field vars to class

* --------------------------------------
*   Description: Object Initializer for the database class
*     Arguments: _cAlias     - the alias of the data table
*                cWho        - the datatable name
*                aIndex      - the array of index names to be set 
*                lShared     - open the data table exclusive or shared mode
*       Returns: self
*   Assumptions: that the data table and indexes exist
* --------------------------------------
METHOD FUNCTION oDbfNew(_cAlias,cWho,aIndex,lShared)
local x,cnt,;
      lOpenMode := if( lShared==NIL,.t.,lShared) // default to shared

::Who := cWho       
::cAlias := _cAlias

dbUseArea( .T.,, (::who), (::cAlias), (lOpenMode) )  // open the dbf

::FldInit()           // create afield as array for fieldnames

if valtype(aIndex) == 'C'               // is there only one index to use?
   dbSetIndex( (aIndex) )
elseif valtype(aIndex) == 'A'           // else parse through the array...
   for x = 1 to len(aIndex)
       dbSetIndex( (aIndex[x]) )
   next
endif

RETURN Self

****
* --------------------------------------
*   Description: Field Variable Initializer for the current data table
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbffldInit
local nCnt, cCnt, fild, Me:=qself()

********** obsolete, see classhandle() below... 
* variable offset is just the length of the class. (it is stored as name and number of variables )
//      nposition := handle[ len(handle),1 ],;       // the last element in handle should be current position
//      nofset    := if( ::nNewOffset==NIL,handle[ len(handle),2 ],::nNewOffset )

local nposition := Me:classhandle()                  // should be current class position

::nOffset := len( Me )                                  // save original variable count

FOR nCnt := 1 TO (::cAlias)->(FCOUNT())                   // populate array[1] with fieldnames
    fild := (::cAlias)->(FIELDNAME(nCnt))

    aadd( self, FILD )         // add to the self array
    VAR &( FILD )              // create self:variable (for ooclip classinfo() )

//    cCnt:= padl(LTrim(Str( nCnt + ::nOffSet )), 2, "0")  // original oclip definitions
      cCnt:=      LTrim(Str( nCnt + ::nOffSet, 4, 0 ))     // new      "     "
    
    __classadd( nPosition, Fild, "__IVAR" + cCnt)          // create internal get function (we've only got 100 of these...)
    __classadd( nPosition, "_" + Fild, "__SIVAR" + cCnt)   // create internal set function

NEXT

*::nNewOffset := ::nOffset + nCnt       // save new variable count

RETURN Self

******************************  basic browse

* --------------------------------------
*   Description: Basic Browse for the current data table
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfBrowse
(::cAlias)->(browse())
RETURN Self

****************************** record movement

* --------------------------------------
*   Description: Basic Browse for the current data table
*     Arguments: Num          - the number of records to skip
*                                10 - skip next ten records
*                               -10 - skip back ten records
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfSkip(num)
(::cAlias)->(DbSkip( num ))
RETURN Self

****
* --------------------------------------
*   Description: end of file check for current Object 
*     Arguments: None
*       Returns: true if positioned at end of file
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfEof
RETURN (::cAlias)->(Eof())

****
* --------------------------------------
*   Description: beginning of file check for current Object 
*     Arguments: None
*       Returns: true if positioned at beginning of file
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfBof
RETURN (::cAlias)->(Bof())

****
* --------------------------------------
*   Description: beginning of file positioning for current Object 
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfGoTop
(::cAlias)->(DbGoTop())
RETURN Self

****
* --------------------------------------
*   Description: end of file positioning for current Object 
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfGoBot
(::cAlias)->(DbGoBottom())
RETURN Self

*************************** record and file handling

* --------------------------------------
*   Description: add a record at end of file for current Object 
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfAppend
(::cAlias)->(DbAppend())
RETURN Self

****
* --------------------------------------
*   Description: delete current record for current Object 
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfDelete
(::cAlias)->(DbDelete())
RETURN Self

****
* --------------------------------------
*   Description: un-delete current deleted record for current Object 
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfRecall
(::cAlias)->(DbRecall())
RETURN Self

****
* --------------------------------------
*   Description: Update current indexs for current Object 
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfReIndex
(::cAlias)->(DbReIndex())
RETURN Self

****
* --------------------------------------
*   Description: Close current Object data table
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfKill
(::cAlias)->(DbCloseArea())
RETURN Self

*************************** record and file locking

* --------------------------------------
*   Description: Lock current record of current Object data table
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfRlock
do while !(::cAlias)->(rlock())
enddo
RETURN Self

****
* --------------------------------------
*   Description: Lock entire current Object data table
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfFlock
do while !(::cAlias)->(flock())
enddo
RETURN Self

****
* --------------------------------------
*   Description: Un-Lock entire current Object data table
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfUnlock
(::cAlias)->(dbunlock())
RETURN Self

*************************** record data read and write
  
* --------------------------------------
*   Description: Populate class field variables from current record 
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfRead()
local nCnt

for nCnt := 1 to (::cAlias)->(fcount())
    self[ nCnt+ ::nOffSet ] := (::cAlias)->(fieldget(nCnt))
next

return self

****
* --------------------------------------
*   Description: Populate current record from class field variables
*     Arguments: None
*       Returns: self
*   Assumptions: NONE
* --------------------------------------
METHOD FUNCTION oDbfWrite()
   local nCnt

   self:RLock()
   for nCnt := 1 TO (self:cAlias)->(fcount())
       (::cAlias)->( fieldput( nCnt, self[ nCnt + ::nOffSet ] ))
   next
   self:Unlock()
   
return self
