// here are some new xcommands that allow windows (ala 5win) syntax to be
// used and yet still work correctly inside each screen object.

#xcommand DEFINE <oDlg> [<clauses,...>]  => DEFINE DIALOG <oDlg> [<clauses>] 

#xcommand DEFINE DIALOG <oDlg> ;
             [ FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ] ;
             [ TITLE <cTitle> ] ;
             [ TMR  <lTmr>    ] ;
             [ MENU <aMenu> ] ;
             [ STYLE <nStyle> ] ;
             [ <color: COLOR, COLORS> <cClrText> ] ;
             [ <shadside: SSIDE,SHADSIDE,SIDE> <cSide> ] ;
             [ <shadclr: SCLR,SHADCLR,SCOLOR,SHADCOLOR> <cShade> ] ;
       => ;
          <oDlg> := oScr():New( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
                 <cTitle>, <lTmr>, <aMenu>,                           ;
                 <nStyle>, <cClrText>,                                ; 
                 <cSide>, <cShade>      );                            ;                           
          <oDlg>:Begin()

#xcommand ACTIVATE <oDlg>          => ACTIVATE DIALOG <oDlg>
          
#xcommand ACTIVATE DIALOG <oDlg>   => <oDlg>:Exec()

#xcommand DEACTIVATE <oDlg>          => DEACTIVATE DIALOG <oDlg>

#xcommand DEACTIVATE DIALOG <oDlg> => <oDlg>:Hide()

// **********************************************************************

// here are some new commands that allow normal cliper syntax to be
// used and yet still work correctly inside each screen object.


#xtranslate ifnil(<param>,<value>)                                      ;
      =>  IIF( <param> == NIL, <value>, <param> )   

//  @..SAY
#command @ <row>, <col> <o>:SAY <xpr>                                   ;
                        [PICTURE <pic>]                                 ;
                        [COLOR <color>]                                 ;
                                                                        ;
      => DevPos( <row>+<o>:nScrTop, <col>+<o>:nScrLeft )                ;
       ; DevOutPict( <xpr>, <pic> [, <color>] )


#command @ <row>, <col> <o>:SAY <xpr>                                   ;
                        [COLOR <color>]                                 ;
                                                                        ;
      => DevPos( <row>+<o>:nScrTop, <col>+<o>:nScrLeft )                ;
       ; DevOut( <xpr> [, <color>] )


//  @..GET
#command @ <row>, <col> <o>:GET <var>                                   ;
                        [PICTURE <pic>]                                 ;
                        [VALID <valid>]                                 ;
                        [WHEN <when>]                                   ;
                        [SEND <msg>]                                    ;
                                                                        ;
      => @ (<row>+<o>:nScrTop), (<col>+<o>:nScrLeft) GET <var>              ;
                        [PICTURE <pic>]                                 ;
                        [VALID <valid>]                                 ;
                        [WHEN <when>]                                   ;
                        [SEND <msg>]

//      => SetPos( <row>+<o>:nScrTop, <col>+<o>:nScrLeft )                ;
//       ; AAdd(                                                          ;
//           GetList,                                                     ;
//           _GET_( <var>, <"var">, <pic>, <{valid}>, <{when}> ):display();
//             )                                                          ;
//      [; ATail(GetList):<msg>]


//  @..SAY..GET
#command @ <row>, <col> <o>:SAY <sayxpr>                                    ;
                        [<sayClauses,...>]                              ;
                        GET <var>                                       ;
                        [<getClauses,...>]                              ;
                                                                        ;
      => @ <row>, <col> <o>:SAY <sayxpr> [<sayClauses>]                 ;
       ; @ <row>, <col>+len(<sayxpr>)+1 <o>:GET <var> [<getClauses>]


// @..GET..RANGE (preprocessed to @..GET..VALID)
#command @ <row>, <col> <o>:GET <var>                                   ;
                        [<clauses,...>]                                 ;
                        RANGE <lo>, <hi>                                ;
                        [<moreClauses,...>]                             ;
                                                                        ;
      => @ <row>, <col> <o>:GET <var>                                   ;
                        [<clauses>]                                     ;
                        VALID {|_1| RangeCheck(_1,, <lo>, <hi>)}        ;
                        [<moreClauses>]
                                    

// @..GET COLOR
#command @ <row>, <col> <o>:GET <var>                                   ;
                        [<clauses,...>]                                 ;
                        COLOR <color>                                   ;
                        [<moreClauses,...>]                             ;
                                                                        ;
      => @ <row>, <col> <o>:GET <var>                                   ;
                        [<clauses>]                                     ;
                        SEND colorDisp(<color>)                         ;
                        [<moreClauses>]




//  @..PROMPT
#command @ <row>, <col> <o>:PROMPT <xpr>                                ;
                                                                        ;
      => __AtPrompt( <row>+<o>:nScrTop, <col>+<o>:nScrLeft, <xpr> , )


// ************* text mode re-definition box styles *************

#define	N_SINGLE    (CHR(218)+CHR(195)+CHR(191)+CHR(225)+CHR(224)+CHR(203)+CHR(192)+CHR(179)+" ")
// #define N_LOWBOX    (CHR(160)+CHR(161)+CHR(162)+CHR(227)+CHR(228)+CHR(229)+CHR(230)+CHR(231)+" ")

#define HOUR_ICO    chr(127)
#define B_UP        chr(181)+chr(182)
#define B_DN        chr(183)+chr(184)
#define RADIO_ON    chr(198)+chr(199)
#define RADIO_OFF   chr(189)+chr(190)
#define DRV_ICO     chr(207)+chr(208)
#define DOC_ICO     chr(209)+chr(210)
#define FLD_ICO     chr(211)+chr(212)
#define DBF_ICO     chr(213)+chr(214)
#define B_ESC       chr(215)+chr(216)
